//===========================================================================
//
// Animator.h
//
// By Poman So
//
//===========================================================================

#ifndef _Animator_h_
#define _Animator_h_

#include "GUI.h"
#include "Vector.h"


//---------------------------------------------------------------------------
//
//	Animator Class
//
//---------------------------------------------------------------------------
class Animator: public DTaskWindow{
	RadioBox     fieldbox,radiobox;
	Graphic3DBox graphbox;
	PushButton   pushbutton;
	Boolean	     connected,removeHL;
	float	     mf;
	int	     fb_statebits;
	VecU	     p1,p2;
public:
	Animator(Window &w, char *label, Animator *A=0);
	Status	 WindowCB(CBTag tag);
	Status	 ChildCB(Window *w, CBTag tag);
	fstream	 &IO(fstream &fs);
	Animator *Previous(){return (Animator*)previous;}
	Animator *Next(){return (Animator*)next;}
	Boolean  Connected(){return connected;}
	void	 Connect(Boolean c=True){connected=c;}
	void	 DrawGraph();
	void	 SetSamplingPlane(int *p);
	void	 Init();
	void	 Update(Boolean must_refresh=False);
};//--- Animator ---//



#endif

//===========================================================================
//
// End of Animator.h
//
//===========================================================================
