//===========================================================================
//
// IntN.C
//
// By Poman So
//
//===========================================================================

#include "IntN.h"

//---------------------------------------------------------------------------
//
//	Int2 Class
//
//---------------------------------------------------------------------------
      Int2::Int2(){x=y=0;}
      Int2::Int2(Real a, Real b){x=int(a); y=int(b);}
Int2  Int2::operator+ (const Int2& a){Int2 c(x+a.x,y+a.y); return c;}
Int2& Int2::operator+=(const Int2& c){x+=c.x; y+=c.y; return *this;}
Int2  Int2::operator- (const Int2& a){Int2 c(x-a.x,y-a.y); return c;}
Int2& Int2::operator-=(const Int2& c){x-=c.x; y-=c.y; return *this;}
Int2  Int2::operator/ (const Int2& a){Int2 c(x/a.x,y/a.y); return c;}
Int2  Int2::operator/ (Real a){Int2 c(x/a,y/a); return c;}
Int2& Int2::operator/=(Real a){x=int(x/a); y=int(y/a); return *this;}
Int2  Int2::operator* (const Int2& a){Int2 c(x*a.x,y*a.y); return c;}
Int2  Int2::operator* (Real a){Int2 c(x*a,y*a); return c;}
Int2& Int2::operator*=(Real a){x=int(x*a); y=int(y*a); return *this;}
int   Int2::operator==(const Int2& a){return (x==a.x && y==a.y)?1:0;}
int   Int2::operator!=(const Int2& a){return (x!=a.x || y!=a.y)?1:0;}
Int2& Int2::operator= (const Int2& a){x=a.x; y=a.y; return *this;}

Int2 operator* (Real a, Int2& b){Int2 c(a*b.x,a*b.y); return c;}

Int2 Min(const Int2& a, const Int2& b){
  Int2 c((a.x<b.x)?a.x:b.x,(a.y<b.y)?a.y:b.y); return c;
}//--- Int2::Min ---//

Int2 Max(const Int2& a, const Int2& b){
  Int2 c((a.x>b.x)?a.x:b.x,(a.y>b.y)?a.y:b.y); return c;
}//--- Int2::Max ---//



//---------------------------------------------------------------------------
//
//	Int4 Class
//
//---------------------------------------------------------------------------
      Int4::Int4():p1(),p2(){}
      Int4::Int4(Int2 P1, Int2 P2):p1(P1),p2(P2){}
      Int4::Int4(Real x1,Real y1,Real x2,Real y2):p1(x1,y1),p2(x2,y2){}
Int2  Int4::P1(){return p1;}
Int2  Int4::P2(){return p2;}
Int4& Int4::operator=(const Int4 &a){p1=a.p1; p2=a.p2; return *this;}

Int4 Min(const Int4& a, const Int4& b){
  Int4 c(Min(a.p1,b.p1),Min(a.p2,b.p2)); return c;
}//--- Int4::Min ---//

Int4 Max(const Int4& a, const Int4& b){
  Int4 c(Max(a.p1,b.p1),Max(a.p2,b.p2)); return c;
}//--- Int4::Max ---//


int Int4::Okay(){
  return (p2.x<p1.x || p2.y<p1.y)?0:1;
}//--- Int4::Okay ---//


int Int4::Intersect(const Int4 &a, Int4 &b){
#ifdef __ActiveCC
Int4 i4(Max(p1,a.p1),Min(p2,a.p2));
  b = i4;
#else
  b.p1 = Max(p1,a.p1);
  b.p2 = Min(p2,a.p2);
#endif
  return b.Okay()?1:0;
}//--- Int4::Intersect ---//


int Int4::Different(const Int4 &a, Int4 *b){
Int4 i,*c=b;
  if (Intersect(a,i)){
    *c=Int4(p1.x,p1.y,i.p1.x-1,i.p2.y);	if (c->Okay()) c++;
    *c=Int4(i.p1.x,p1.y,p2.x,i.p1.y-1);	if (c->Okay()) c++;
    *c=Int4(i.p2.x+1,i.p1.y,p2.x,p2.y);	if (c->Okay()) c++;
    *c=Int4(p1.x,i.p2.y+1,i.p2.x,p2.y);	if (c->Okay()) c++;
    return (c-b);
  }
  else
    return 0;
}//--- Int4::Different ---//

//===========================================================================
//
// End of IntN.C
//
//===========================================================================
