//===========================================================================
// Real.h
//
// By Poman So
//
//===========================================================================

#ifndef _Real_h_
#define _Real_h_ 1

#include <float.h>
#include <fstream>
using namespace std;

#if   _Real_h_ == 1
typedef float Real;
#define EPSILON FLT_EPSILON*1E2
#elif _Real_h_ == 2
typedef double Real;
#define EPSILON DBL_EPSILON*1E3
#endif

#define Uint unsigned

typedef float Float7[7];
typedef float Float8[8];
typedef enum Boolean{False=0,True};

extern int iostate_;
fstream &DataIO(fstream &fs, void *data, int size);

#ifdef no_template_
inline int    Min(int    x, int    y){return (x<y)?x:y;}
inline int    Max(int    x, int    y){return (x>y)?x:y;}
inline float  Min(float  a, float  b){return (a<b)?a:b;}
inline float  Max(float  a, float  b){return (a>b)?a:b;}
inline double Min(double a, double b){return (a<b)?a:b;}
inline double Max(double a, double b){return (a>b)?a:b;}
fstream &operator|(fstream &fs, char     &c);
fstream &operator|(fstream &fs, int      &i);
fstream &operator|(fstream &fs, unsigned &u);
fstream &operator|(fstream &fs, Boolean  &b);
fstream &operator|(fstream &fs, float    &f);
fstream &operator|(fstream &fs, double   &d);
#else
template<class T> inline T Min(T x, T y){ return (x<y)?x:y; }
template<class T> inline T Max(T x, T y){ return (x>y)?x:y; }
template<class T> inline fstream& operator|(fstream &fs, T &t){
  return DataIO(fs,&t,sizeof(T));
}//--- operator| ---//
#endif

#endif

//===========================================================================
//
// End of Real.h
//
//===========================================================================
