//===========================================================================
//
// Vector.C
//
// By Poman So
//
//===========================================================================

#include <math.h>
#include "Vector.h"


//
//	constructors
//
     VecR::VecR(){x=y=z=0;}
     VecR::VecR(Real a, Real b, Real c){x=a; y=b; z=c;}
//
//	functions
//
Real VecR::mods(){return x*x+y*y+z*z;}
Real VecR::mod(){return sqrt(x*x+y*y+z*z);}
VecR VecR::cross(VecR b)	{
	  return VecR(y*b.z-z*b.y,z*b.x-x*b.z,x*b.y-y*b.x);
	}
Real VecR::dot(VecR b){return x*b.x+y*b.y+z*b.z;}

//
//	operators
//
     VecR::operator VecU(){return VecU(Uint(x),Uint(y),Uint(z));}
     VecR::operator VecI(){return VecI(int(x),int(y),int(z));}
VecR VecR::operator- (){x=-x; y=-y; z=-z; return *this;}
VecR VecR::operator+=(VecR v){x+=v.x; y+=v.y; z+=v.z; return *this;}
VecR VecR::operator-=(VecR v){x-=v.x; y-=v.y; z-=v.z; return *this;}
VecR VecR::operator*=(VecR v){x*=v.x; y*=v.y; z*=v.z; return *this;}
VecR VecR::operator*=(Real r){x*=r; y*=r; z*=r; return *this;}
VecR VecR::operator/=(VecR v){x/=v.x; y/=v.y; z/=v.z; return *this;}
VecR VecR::operator/=(Real r){x/=r; y/=r; z/=r; return *this;}
//
//	functions and operators to be used by VecR, VecI and VecU
//
        Real Mods(VecR v){return v.x*v.x+v.y*v.y+v.z*v.z;}
        Real Mod(VecR v){return sqrt(v.x*v.x+v.y*v.y+v.z*v.z);}
	VecR cross(VecR a, VecR b){return a.cross(b);}
	Real dot(VecR a, VecR b){return a.dot(b);}
      	VecR operator+(VecR u, VecR v){
	  u.x+=v.x; u.y+=v.y; u.z+=v.z; return u;
	}
      	VecR operator-(VecR u, VecR v){
	  u.x-=v.x; u.y-=v.y; u.z-=v.z; return u;
	}
      	VecR operator*(VecR u, VecR v){
	  u.x*=v.x; u.y*=v.y; u.z*=v.z; return u;
	}
      	VecR operator*(VecR u, Real r){u.x*=r; u.y*=r; u.z*=r; return u;}
        VecR operator*(Real r, VecR u){u.x*=r; u.y*=r; u.z*=r; return u;}
      	VecR operator/(VecR u, VecR v){
	  u.x/=v.x; u.y/=v.y; u.z/=v.z; return u;
	}
      	VecR operator/(VecR u, Real r){u.x/=r; u.y/=r; u.z/=r; return u;}
        VecR operator/(Real r, VecR u){u.x=r/u.x;u.y=r/u.y;u.z=r/u.z;return u;}
//
//	constructors
//
     VecI::VecI(){x=y=z=0;}
     VecI::VecI(int a, int b, int c){x=a; y=b; z=c;}
//
//	functions
//
int  VecI::mods(){return x*x+y*y+z*z;}
Real VecI::mod(){return sqrt(x*x+y*y+z*z);}
VecR VecI::cross(VecR b){return -b.cross(*this);}
Real VecI::dot(VecR b){return b.dot(*this);}

//
//	operators
//
     VecI::operator VecU(){return VecU(Uint(x),Uint(y),Uint(z));}
     VecI::operator VecR(){return VecR(Real(x),Real(y),Real(z));}
VecI VecI::operator- (){x=-x; y=-y; z=-z; return *this;}
VecI VecI::operator+=(VecI v){x+=v.x; y+=v.y; z+=v.z; return *this;}
VecI VecI::operator-=(VecI v){x-=v.x; y-=v.y; z-=v.z; return *this;}
VecI VecI::operator*=(VecI v){x*=v.x; y*=v.y; z*=v.z; return *this;}
VecI VecI::operator*=(Real r){x=int(x*r); y=int(y*r); z=int(z*r);return *this;}
VecI VecI::operator/=(VecI v){x/=v.x; y/=v.y; z/=v.z; return *this;}
VecI VecI::operator/=(Real r){x=int(x/r); y=int(y/r); z=int(z/r);return *this;}

//
//	constructors
//
     VecU::VecU(){x=y=z=0;}
     VecU::VecU(Uint a, Uint b, Uint c){x=a; y=b; z=c;}
//
//	functions
//
Uint VecU::mods(){return x*x+y*y+z*z;}
Real VecU::mod(){return sqrt(x*x+y*y+z*z);}
VecR VecU::cross(VecR b){return b.cross(*this);}
Real VecU::dot(VecR b){return -b.dot(*this);}

//
//	operators
//
     VecU::operator VecI(){return VecI(int(x),int(y),int(z));}
     VecU::operator VecR(){return VecR(Real(x),Real(y),Real(z));}
VecU VecU::operator-(){x=-x; y=-y; z=-z; return *this;}
VecU VecU::operator+=(VecU v){x+=v.x; y+=v.y; z+=v.z; return *this;}
VecU VecU::operator-=(VecU v){x-=v.x; y-=v.y; z-=v.z; return *this;}
VecU VecU::operator*=(VecU v){x*=v.x; y*=v.y; z*=v.z; return *this;}
VecU VecU::operator*=(Real r){x=int(x*r); y=int(y*r); z=int(z*r);return *this;}
VecU VecU::operator/=(VecU v){x/=v.x; y/=v.y; z/=v.z; return *this;}
VecU VecU::operator/=(Real r){x=int(x/r); y=int(y/r); z=int(z/r);return *this;}

//===========================================================================
//
// End of Vector.C
//
//===========================================================================
