//===========================================================================
//
// Vector.h
//
// By Poman So
//
//===========================================================================

#ifndef _Vector_h_
#define _Vector_h_

#include "Real.h"

class VecI;
class VecU;

class VecR{
public:
	Real x,y,z;	// x,y,z component of the cartesian coordinate
//
//	constructors
//
	VecR();
	VecR(Real a, Real b, Real c);
//
//	functions
//
	Real mods();
	Real mod();
	VecR cross(VecR b);
	Real dot(VecR b);
	char *str(char *s);

//
//	operators
//
	operator VecU();
	operator VecI();
	VecR operator- ();
	VecR operator+=(VecR v);
	VecR operator-=(VecR v);
	VecR operator*=(VecR v);
	VecR operator*=(Real r);
	VecR operator/=(VecR v);
	VecR operator/=(Real r);
//
//	friend functions and operators to be used by VecR, VecI and VecU
//
friend  Real Mods(VecR v);
friend  Real Mod(VecR v);
friend	VecR cross(VecR a, VecR b);
friend  Real dot(VecR a, VecR b);
friend	VecR operator+(VecR u, VecR v);
friend	VecR operator-(VecR u, VecR v);
friend	VecR operator*(VecR u, VecR v);
friend	VecR operator*(VecR u, Real r);
friend  VecR operator*(Real r, VecR u);
friend	VecR operator/(VecR u, VecR v);
friend	VecR operator/(VecR u, Real r);
friend  VecR operator/(Real r, VecR u);
};//-- VecR ---//


class VecI{
public:
	int x,y,z;
//
//	constructors
//
	VecI();
	VecI(int a, int b, int c);
//
//	functions
//
	int  mods();
	Real mod();
	VecR cross(VecR b);
	Real dot(VecR b);
//
//	operators
//
	operator VecU();
	operator VecR();
	VecI operator- ();
	VecI operator+=(VecI v);
	VecI operator-=(VecI v);
	VecI operator*=(VecI v);
	VecI operator*=(Real r);
	VecI operator/=(VecI v);
	VecI operator/=(Real r);
};//--- VecI ---//


class VecU{
public:
	Uint x,y,z;
//
//	constructors
//
	VecU();
	VecU(Uint a, Uint b, Uint c);
//
//	functions
//
	Uint mods();
	Real mod();
	VecR cross(VecR b);
	Real dot(VecR b);
//
//	operators
//
	operator VecI();
	operator VecR();
	VecU operator-();
	VecU operator+=(VecU v);
	VecU operator-=(VecU v);
	VecU operator*=(VecU v);
	VecU operator*=(Real r);
	VecU operator/=(VecU v);
	VecU operator/=(Real r);
};//--- VecU ---//

#endif

//===========================================================================
//
// End of Vector.h
//
//===========================================================================
